//
// Created by bspeice on 12/28/24.
//
#pragma once

#include <slang-com-ptr.h>
#include <slang.h>

#include <memory>

#include "rust/cxx.h"

namespace slang_compiler {

class GlobalSession {
public:
  explicit GlobalSession();
  [[nodiscard]] SlangResult createSession(const slang::SessionDesc& desc, slang::ISession** outSession) const;

  slang::IGlobalSession& getSlangSession();

private:
  Slang::ComPtr<slang::IGlobalSession> global_session_;
};

std::shared_ptr<GlobalSession> create_global_session();

struct SessionDesc;
class Session {
public:
  Session(std::shared_ptr<GlobalSession> global_session, Slang::ComPtr<slang::ISession>&& session);
  [[nodiscard]] int64_t get_loaded_module_count() const noexcept;

private:
  const std::shared_ptr<GlobalSession> global_session_;
  Slang::ComPtr<slang::ISession> session_;
};

std::unique_ptr<Session> create_session(SessionDesc session_desc, std::shared_ptr<GlobalSession> global_session);

} // namespace slang_compiler
